Executing important commands directly inside the vnfs
[osm/vim-emu.git] / utils / ci / check_manual_usage_example.sh
1 #!/bin/bash
2 export DOCKER_HOST="unix:///var/run/docker.sock"
3
4 set -e
5 set -x
6
7 W() {
8 # Wait until a line appears in the screen session.
9 # It starts from the beginning of the log and exits after the first match.
10 local T=${2:-20s}
11 #timeout -k 3s ${T} stdbuf -o0 grep -q -m 1 "^${1}" <(tail -F -n+0 screenlog.0)
12 # (HACK) As Jenkins blocks subshell, we must use an intermediate script
13 local SUBF=$(mktemp)
14 chmod +x ${SUBF}
15 cat > ${SUBF} <<- EOF
16 #!/bin/bash -e
17 while true; do
18 if strings screenlog.0 | grep -m 1 "\${1}"; then
19 exit 0
20 fi
21 sleep 0.5s
22 done
23 EOF
24 local RES=0
25 timeout -k 3s ${T} ${SUBF} "${1}" || RES=$?
26 rm -f ${SUBF}
27 if [ ! "$RES" = "0" ]; then
28 sync
29 echo -e "\n\n\n(Debug) Error while waiting for a pattern to appear in screenlog.0\n\n\n"
30 strings screenlog.0
31 fi
32 return ${RES}
33 }
34
35 Cmd() {
36 # Send a command to the screen session, aka into the containernet prompt
37 screen -S sonemu -X stuff "${1}^M"
38 }
39
40 Vnf() {
41 # Send a command inside the vnf1 container
42 docker exec -t "mn.${1}" /bin/bash -c "${2}" && sync
43 }
44
45
46 if ! screen --version | grep 'Screen version'; then
47 # Install screen and do an initial cleanup
48 sudo apt-get update -qq -y
49 sudo apt-get install -y screen
50 screen --version | grep 'Screen version'
51 fi
52 if ! timeout --version; then
53 # Install coreutils for the timeout command
54 sudo apt-get update -qq -y
55 sudo apt-get install -y coreutils
56 timeout --version
57 fi
58 # Initial cleanup
59 pkill --signal KILL -f 'SCREEN -L -S sonemu' || true
60 sleep 1s
61 screen -wipe || true
62 rm -f screenlog.0
63
64
65 # Start containernet with a topology
66 screen -L -S sonemu -d -m sudo python src/emuvim/examples/simple_topology.py
67 # Setup screen for immediate flusing
68 screen -S sonemu -X logfile flush 0
69 # Wait for the cli to start
70 W '^*** Starting CLI:' 60s
71 # Print nodes
72 Cmd 'nodes'
73 # Start vnf1
74 son-emu-cli compute start -d datacenter1 -n vnf1 && sleep 1s
75 # Start vnf2
76 son-emu-cli compute start -d datacenter1 -n vnf2 && sleep 1s
77 # List compute nodes
78 son-emu-cli compute list && sleep 1s
79 sync # avoid text overlapping
80 # Gather some infos
81 Cmd 'sh sync'
82 Cmd 'sh echo "... starting various checks"'
83 sync # avoid text overlappin
84 Cmd 'links'
85 Vnf vnf1 'ifconfig'
86 Vnf vnf2 'ifconfig'
87 # Try to ping vnfs
88 IP_2=$(Vnf vnf2 'ip -f inet -o addr show vnf2-eth0' | cut -d\ -f 7 | cut -d/ -f 1)
89 # IP_1=$(Vnf vnf1 'ip -f inet -o addr show vnf1-eth0' | cut -d\ -f 7 | cut -d/ -f 1)
90 OUTPUT_A=$(Vnf vnf1 "ping -v -c 2 ${IP_2}")
91 Cmd 'quit'
92 # Wait for sonemu to end
93 W '*** Done'
94
95 echo -e '\n\n******************* Result ******************\n\n'
96 strings screenlog.0
97 echo -e '\n\n*********************************************\n\n'
98
99
100 # Check the ping result
101 if echo ${OUTPUT_A} | grep ', 2 received'; then
102 echo 'No problems detected'
103 exit 0
104 else
105 echo 'Ping is broken !'
106 exit 1
107 fi